

export default (navigation => ({
  ...navigation,
  goBack: key => {
    return navigation.dispatch({
      type: 'Back',
      key: key === undefined ? navigation.state.key : key
    });
  },
  navigate: (routeName, params, action) => {
    return navigation.dispatch({
      type: 'Navigate',
      routeName,
      params,
      action
    });
  },
  /**
   * For updating current route params. For example the nav bar title and
   * buttons are based on the route params.
   * This means `setParams` can be used to update nav bar for example.
   */
  setParams: params => navigation.dispatch({ type: 'SetParams', params, key: navigation.state.key })
})); /**
      * 
      *
      * Helpers for navigation.
      */