'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _ReactComponentWithPureRenderMixin = require('react/lib/ReactComponentWithPureRenderMixin');

var _ReactComponentWithPureRenderMixin2 = _interopRequireDefault(_ReactComponentWithPureRenderMixin);

var _HeaderTitle = require('./HeaderTitle');

var _HeaderTitle2 = _interopRequireDefault(_HeaderTitle);

var _HeaderBackButton = require('./HeaderBackButton');

var _HeaderBackButton2 = _interopRequireDefault(_HeaderBackButton);

var _HeaderStyleInterpolator = require('./HeaderStyleInterpolator');

var _HeaderStyleInterpolator2 = _interopRequireDefault(_HeaderStyleInterpolator);

var _PropTypes = require('../PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _TransitionConfigs = require('./TransitionConfigs');

var _TransitionConfigs2 = _interopRequireDefault(_TransitionConfigs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var APPBAR_HEIGHT = _reactNative.Platform.OS === 'ios' ? 44 : 56;
var STATUSBAR_HEIGHT = _reactNative.Platform.OS === 'ios' ? 20 : 0;

var Header = function (_React$Component) {
  _inherits(Header, _React$Component);

  function Header() {
    _classCallCheck(this, Header);

    return _possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).apply(this, arguments));
  }

  _createClass(Header, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return _ReactComponentWithPureRenderMixin2.default.shouldComponentUpdate.call(this, nextProps, nextState);
    }

    // propTypes for people who don't use Flow

  }, {
    key: '_renderLeft',
    value: function _renderLeft(props) {
      return this._renderSubView(props, 'left', this.props.renderLeftComponent, _HeaderStyleInterpolator2.default.forLeft);
    }
  }, {
    key: '_renderTitle',
    value: function _renderTitle(props, options) {
      var style = {};

      if (_reactNative.Platform.OS === 'android') {
        if (!options.hasLeftComponent) {
          style.left = 0;
        }
        if (!options.hasRightComponent) {
          style.right = 0;
        }
      }

      return this._renderSubView(_extends({}, props, { style: style }), 'title', this.props.renderTitleComponent, _HeaderStyleInterpolator2.default.forCenter);
    }
  }, {
    key: '_renderRight',
    value: function _renderRight(props) {
      return this._renderSubView(props, 'right', this.props.renderRightComponent, _HeaderStyleInterpolator2.default.forRight);
    }
  }, {
    key: '_renderSubView',
    value: function _renderSubView(props, name, renderer, styleInterpolator) {
      var scene = props.scene,
          navigationState = props.navigationState;
      var index = scene.index,
          isStale = scene.isStale,
          key = scene.key;


      var offset = navigationState.index - index;

      if (Math.abs(offset) > 2) {
        // Scene is far away from the active scene. Hides it to avoid unnecessary
        // rendering.
        return null;
      }

      var subViewProps = _extends({}, props, {
        onNavigateBack: this.props.onNavigateBack
      });
      var subView = renderer(subViewProps);
      if (subView === null) {
        return null;
      }

      var pointerEvents = offset !== 0 || isStale ? 'none' : 'box-none';
      return _react2.default.createElement(
        _reactNative.Animated.View,
        {
          pointerEvents: pointerEvents,
          key: name + '_' + key,
          style: [styles.item, styles[name], props.style, styleInterpolator(props)]
        },
        subView
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // eslint-disable-next-line no-unused-vars
      var _props = this.props,
          scenes = _props.scenes,
          scene = _props.scene,
          style = _props.style,
          position = _props.position,
          progress = _props.progress,
          rest = _objectWithoutProperties(_props, ['scenes', 'scene', 'style', 'position', 'progress']);

      var leftComponents = null;
      var titleComponents = null;
      var rightComponents = null;

      if (this.props.mode === 'float') {
        var scenesProps = scenes.map(function (scene, index) {
          var props = _PropTypes2.default.extractSceneRendererProps(_this2.props);
          props.scene = scene;
          props.index = index;
          return props;
        });
        leftComponents = scenesProps.map(this._renderLeft, this);
        rightComponents = scenesProps.map(this._renderRight, this);
        titleComponents = scenesProps.map(function (props, i) {
          return _this2._renderTitle(props, {
            hasLeftComponent: leftComponents && !!leftComponents[i],
            hasRightComponent: rightComponents && !!rightComponents[i]
          });
        });
      } else {
        var staticRendererProps = _extends({}, this.props, {
          position: new _reactNative.Animated.Value(scene.index),
          progress: new _reactNative.Animated.Value(0)
        });
        leftComponents = this._renderLeft(staticRendererProps);
        rightComponents = this._renderRight(staticRendererProps);
        titleComponents = this._renderTitle(staticRendererProps, {
          hasLeftComponent: !!leftComponents,
          hasRightComponent: !!rightComponents
        });
      }

      return _react2.default.createElement(
        _reactNative.Animated.View,
        _extends({}, rest, { style: [styles.container, style] }),
        _react2.default.createElement(
          _reactNative.View,
          { style: styles.appBar },
          leftComponents,
          titleComponents,
          rightComponents
        )
      );
    }
  }]);

  return Header;
}(_react2.default.Component);

Header.HEIGHT = APPBAR_HEIGHT + STATUSBAR_HEIGHT;
Header.Title = _HeaderTitle2.default;
Header.BackButton = _HeaderBackButton2.default;
Header.defaultProps = {
  renderTitleComponent: function renderTitleComponent(props) {
    var title = String(props.scene.route.title || '');
    return _react2.default.createElement(
      _HeaderTitle2.default,
      null,
      title
    );
  },

  renderLeftComponent: function renderLeftComponent(props) {
    if (props.scene.index === 0 || !props.onNavigateBack) {
      return null;
    }
    return _react2.default.createElement(_HeaderBackButton2.default, {
      onPress: props.onNavigateBack
    });
  },

  renderRightComponent: function renderRightComponent() {
    return null;
  }
};
Header.propTypes = _extends({}, _PropTypes2.default.SceneRendererProps, {
  onNavigateBack: _react.PropTypes.func,
  renderLeftComponent: _react.PropTypes.func,
  renderRightComponent: _react.PropTypes.func,
  renderTitleComponent: _react.PropTypes.func,
  style: _react.PropTypes.any
});


var styles = _reactNative.StyleSheet.create({
  container: {
    paddingTop: STATUSBAR_HEIGHT,
    backgroundColor: _reactNative.Platform.OS === 'ios' ? '#EFEFF2' : '#FFF',
    shadowColor: 'black',
    shadowOpacity: 0.1,
    shadowRadius: _reactNative.StyleSheet.hairlineWidth,
    shadowOffset: {
      height: _reactNative.StyleSheet.hairlineWidth
    },
    elevation: 4
  },
  appBar: {
    height: APPBAR_HEIGHT
  },
  item: {
    flexDirection: 'row',
    alignItems: 'center'
  },
  title: {
    bottom: 0,
    left: 40,
    position: 'absolute',
    right: 40,
    top: 0
  },
  left: {
    bottom: 0,
    left: 0,
    position: 'absolute',
    top: 0
  },
  right: {
    bottom: 0,
    position: 'absolute',
    right: 0,
    top: 0
  }
});

module.exports = Header;