'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactNative = require('react-native');

var _TouchableItem = require('./TouchableItem');

var _TouchableItem2 = _interopRequireDefault(_TouchableItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HeaderBackButton = function HeaderBackButton(_ref) {
  var onPress = _ref.onPress,
      tintColor = _ref.tintColor;
  return _react2.default.createElement(
    _TouchableItem2.default,
    {
      delayPressIn: 0,
      onPress: onPress,
      style: styles.container,
      borderless: true
    },
    _react2.default.createElement(_reactNative.Image, {
      style: styles.button,
      source: require('./assets/back-icon.png'),
      tintColor: tintColor
    })
  );
};

HeaderBackButton.propTypes = {
  onPress: _react.PropTypes.func.isRequired,
  tintColor: _react.PropTypes.string
};

var styles = _reactNative.StyleSheet.create({
  container: {
    alignItems: 'center',
    justifyContent: 'center'
  },
  button: {
    height: 24,
    width: 24,
    margin: _reactNative.Platform.OS === 'ios' ? 10 : 16,
    resizeMode: 'contain',
    transform: [{ scaleX: _reactNative.I18nManager.isRTL ? -1 : 1 }]
  }
});

exports.default = HeaderBackButton;